io8255_a    equ 230h       ; 8255ַ
io8255_b    equ 231h
io8255_c    equ 232h
io8255_k    equ 233h
io8254_0    equ 210h       ; 8254ַ
io8254_1    equ 211h
io8254_k    equ 213h
io8259_0    equ 200h       ; 8259ַ
io8259_1    equ 201h

; ݶζ
data        segment
    count1  dw  0                 ; жϼ
    portcl  db  0ch,12h,21h,12h   ; ̵״̬
    input   db  ?                 ;ʱ
    flag1 db ?	                  ;״̬1
    flag2 db ?	                  ;״̬2

    ;  dev_add  begin
    SPEED   DB  6        ; ת٣ʱ

    ; dev_add end
data        ends

; ջζ
st_ssg      segment stack
    db  256 dup(?)
st_ssg      ends

; ζ
code    segment
    assume  cs:code, ds:data, ss:st_ssg
start:
    cli                       ; ж
    mov ax, data              ; ݶεֵַaxĴ
    mov ds, ax                ; axĴֵdsĴ

    ; ʼ8259оƬ(ICW1żַICW2~4ַ)
    mov dx, io8259_0           ; io8259_0ĵֵַdxĴ
    mov al, 00010011B         ; ʼ1(شƬҪдICW4)
    out dx, al
    mov dx, io8259_1           ; io8259_1ĵֵַdxĴ
    mov al, 00001000B         ; ʼ2ȷжϺ 08h
    out dx, al
    mov al, 00000001B         ; ʼ4
    out dx, al

    ; ж
    push    ds
    mov ax, 0
    mov ds, ax
    lea ax, cs:int_proc      ; int_procڵֵַaxĴ
    mov si, 08h              ; MIR008h
    add si, si
    add si, si  
    mov ds:[si], ax          ; axĴֵ洢жеipλ  si = 20h
    push    cs
    pop ax
    mov ds:[si+2], ax        ; axĴֵ洢жеcsλ
    pop ds
    in  al, dx
    and al, 11111110b
    out dx, al

    ; ʼ8254Ƶ
    mov ax, 0
    mov al, 00110110b    ; 0Զʱ
    mov dx, io8254_k
    out dx, al
    mov ax, 10000        ;ֵ 10000
    mov dx, io8254_0     
    out dx, al
    mov al, ah
    out dx, al

    ; ʼ8255оƬ
    mov dx, io8255_k
    mov al, 10001000b
    out dx, al

   
    sti                     ; ж


;ͨƿ
light:
    call    digital         ; ܳ
    call    motor           ; 
    mov dx, io8255_b
greeen1:cmp count1, 500     ; жǷ5sɵͨ
    ja  yellow1
    mov al, portcl
    out dx, al
    jmp ok
yellow1:cmp count1, 700     ; жǷ2sɵƵ״̬
    ja  greeen2
    mov al, portcl[1]
    out dx, al
    jmp ok
greeen2:cmp count1, 1000        ; жǷ3sӸɵͨ
    ja  yellow2
    mov al, portcl[2]
    out dx, al
    jmp ok
yellow2:cmp count1, 1200        ; жǷ2sӸɵƵ״̬
    ja  finish
    mov al, portcl[3]
    out dx, al
    jmp ok
finish: mov count1, 0       ; һѭcount1Ϊ0
ok: call    digital
    jmp light

;ʾ
digital proc
    begin:
        mov dx, io8255_a
    zhu5:   cmp count1, 100
        ja  zhu4
        mov al, 6Dh
        out dx, al
        jmp exit
    zhu4:   cmp count1, 200
        ja  zhu3
        mov al, 66h
        out dx, al
        jmp exit
    zhu3:   cmp count1, 300
        ja  zhu2
        mov al, 4Fh
        out dx, al
        jmp exit
    zhu2:   cmp count1, 400
        ja  zhu1
        mov al, 5Bh
        out dx, al
        jmp exit
    zhu1:   cmp count1, 500
        ja  zhu22
        mov al, 06h
        out dx, al
        jmp exit
    zhu22:  cmp count1, 600
        ja  zhu11
        mov al, 5Bh
        out dx, al
        jmp exit
    zhu11:  cmp count1, 700
        ja  zhi3
        mov al, 06h
        out dx, al
        jmp exit
    zhi3:   cmp count1, 800
        ja  zhi2
        mov al, 4Fh
        out dx, al
        jmp exit
    zhi2:   cmp count1, 900
        ja  zhi1
        mov al, 5Bh
        out dx, al
        jmp exit
    zhi1:   cmp count1, 1000
        ja  zhi22
        mov al, 06h
        out dx, al
        jmp exit
    zhi22:  cmp count1, 1100
        ja  zhi11
        mov al, 5Bh
        out dx, al
        jmp exit
    zhi11:  cmp count1, 1200
        ja  exit
        mov al, 06h
        out dx, al
    exit:   ret
digital endp

;TODO 
motor proc
    motor_begin:
        mov dx, io8255_k
        mov al, 80h
        out dx, al     ;8255 cڵλ
        mov dx, io8255_c
    motor_work:
        mov al, 01h            ; ˳
        out dx, al     
        call    motor_delay
        mov al, 03h            ; ˳
        out dx, al     
        call    motor_delay
        mov al, 02h            ; ˳
        out dx, al     
        call    motor_delay
        mov al, 06h            ; ˳
        out dx, al     
        call    motor_delay
        mov al, 04h            ; ˳
        out dx, al     
        call    motor_delay
        mov al, 0ch            ; ˳
        out dx, al     
        call    motor_delay
        mov al, 08h            ; ˳
        out dx, al     
        call    motor_delay
        mov al, 09h            ; ˳
        out dx, al     
        call    motor_delay

        ; TODO
        jmp     motor_work
        ;ret
motor endp

;motorʱӳʱ
motor_delay   proc    
        push    ax
        push    cx
        push    dx
        mov     dh, SPEED
    motor_x1:
        mov     cx, 0180h
    motor_x2:
        loop    motor_x2
        dec     dh
        jnz     motor_x1
        pop     dx
        pop     cx
        pop     ax
        ret
motor_delay   endp

;ʱ
delay   proc    near
    push    ax
    push    cx
    push    dx
    mov dl, input   
x1: mov cx, 0ffh
x2: loop    x2
    dec dl
    jnz x1
    pop dx
    pop cx
    pop ax
    ret
delay   endp

;жϷ
int_proc proc far
    push ax
    push dx
    mov dx,io8255_c
    in al,dx
    and al,10000000b     ;ɵж
    jz int1              ;ûнתint1
    mov flag1,1      
int1: in al,dx
     and al,01000000b    ;֧ɵж
     jz int2             ;ûнתint2
     mov flag2,1    

int2:cmp flag1,1
	 jz int3
	 cmp flag2,1
	 jz int4 
	 inc count1       ;жϼ
	 jmp int5
	
int3:mov dx, io8255_b     ;ɵ
    mov al, portcl
    out dx, al
    mov flag1,0
    mov dx,io8255_c
    in al,dx
    and al,10000000b 
    jz int1
    mov flag1,1
	jmp int2
	
int4:mov dx, io8255_b     ; ֧ɵ
	mov al, portcl[2]
    out dx, al
    mov flag2,0
    mov dx,io8255_c
    in al,dx
    and al,01000000b 
    jz int2
    mov flag2,1
    jmp int2
    
int5:mov al, 20h   ;ǰжϴ
    mov dx, io8259_0
    out dx, al
    pop dx
    pop ax
    sti
    iret
int_proc endp
code ends
end start
